diff --git a/arch/arm64/boot/dts/qcom/sdm845-db845c.dts b/arch/arm64/boot/dts/qcom/sdm845-db845c.dts
index 8ba3188ac4c3..ea092e884b45 100644
--- a/arch/arm64/boot/dts/qcom/sdm845-db845c.dts
+++ b/arch/arm64/boot/dts/qcom/sdm845-db845c.dts
@@ -120,9 +120,11 @@ lt9611_3v3: lt9611-3v3 {
 		regulator-min-microvolt = <3300000>;
 		regulator-max-microvolt = <3300000>;
 
-		// TODO: make it possible to drive same GPIO from two clients
-		// gpio = <&tlmm 89 GPIO_ACTIVE_HIGH>;
-		// enable-active-high;
+		/*
+		 * TODO: make it possible to drive same GPIO from two clients
+		 * gpio = <&tlmm 89 GPIO_ACTIVE_HIGH>;
+		 * enable-active-high;
+		 */
 	};
 
 	pcie0_1p05v: pcie-0-1p05v-regulator {
@@ -133,9 +135,11 @@ pcie0_1p05v: pcie-0-1p05v-regulator {
 		regulator-min-microvolt = <1050000>;
 		regulator-max-microvolt = <1050000>;
 
-		// TODO: make it possible to drive same GPIO from two clients
-		// gpio = <&tlmm 90 GPIO_ACTIVE_HIGH>;
-		// enable-active-high;
+		/*
+		 * TODO: make it possible to drive same GPIO from two clients
+		 * gpio = <&tlmm 90 GPIO_ACTIVE_HIGH>;
+		 * enable-active-high;
+		 */
 	};
 
 	cam0_dvdd_1v2: reg_cam0_dvdd_1v2 {
@@ -195,9 +199,11 @@ v5p0_hdmiout: v5p0-hdmiout-regulator {
 		regulator-min-microvolt = <500000>;
 		regulator-max-microvolt = <500000>;
 
-		// TODO: make it possible to drive same GPIO from two clients
-		// gpio = <&tlmm 89 GPIO_ACTIVE_HIGH>;
-		// enable-active-high;
+		/*
+		 * TODO: make it possible to drive same GPIO from two clients
+		 * gpio = <&tlmm 89 GPIO_ACTIVE_HIGH>;
+		 * enable-active-high;
+		 */
 	};
 
 	vbat: vbat-regulator {
@@ -1192,7 +1198,7 @@ camera@10 {
 		compatible = "ovti,ov8856";
 		reg = <0x10>;
 
-		// CAM0_RST_N
+		/* CAM0_RST_N */
 		reset-gpios = <&tlmm 9 GPIO_ACTIVE_LOW>;
 		pinctrl-names = "default";
 		pinctrl-0 = <&cam0_default>;
@@ -1201,7 +1207,8 @@ camera@10 {
 		clock-names = "xvclk";
 		clock-frequency = <19200000>;
 
-		/* The &vreg_s4a_1p8 trace is powered on as a,
+		/*
+		 * The &vreg_s4a_1p8 trace is powered on as a,
 		 * so it is represented by a fixed regulator.
 		 *
 		 * The 2.8V vdda-supply and 1.2V vddd-supply regulators
@@ -1229,10 +1236,10 @@ &cci_i2c1 {
 	camera@60 {
 		compatible = "ovti,ov7251";
 
-		// I2C address as per ov7251.txt linux documentation
+		/* I2C address as per ov7251.txt linux documentation */
 		reg = <0x60>;
 
-		// CAM3_RST_N
+		/* CAM3_RST_N */
 		enable-gpios = <&tlmm 21 GPIO_ACTIVE_HIGH>;
 		pinctrl-names = "default";
 		pinctrl-0 = <&cam3_default>;
@@ -1241,7 +1248,8 @@ camera@60 {
 		clock-names = "xclk";
 		clock-frequency = <24000000>;
 
-		/* The &vreg_s4a_1p8 trace always powered on.
+		/*
+		 * The &vreg_s4a_1p8 trace always powered on.
 		 *
 		 * The 2.8V vdda-supply regulator is enabled when the
 		 * vreg_s4a_1p8 trace is pulled high.
@@ -1257,7 +1265,7 @@ camera@60 {
 		port {
 			ov7251_ep: endpoint {
 				data-lanes = <0 1>;
-//				remote-endpoint = <&csiphy3_ep>;
+/*				remote-endpoint = <&csiphy3_ep>; */
 			};
 		};
 	};
diff --git a/arch/arm64/boot/dts/qcom/sdm845-oneplus-common.dtsi b/arch/arm64/boot/dts/qcom/sdm845-oneplus-common.dtsi
index 5d99908d4628..a51ec7fb1746 100644
--- a/arch/arm64/boot/dts/qcom/sdm845-oneplus-common.dtsi
+++ b/arch/arm64/boot/dts/qcom/sdm845-oneplus-common.dtsi
@@ -50,7 +50,8 @@ key-vol-up {
 	};
 
 	reserved-memory {
-		/* The rmtfs_mem needs to be guarded due to "XPU limitations"
+		/*
+		 * The rmtfs_mem needs to be guarded due to "XPU limitations"
 		 * it is otherwise possible for an allocation adjacent to the
 		 * rmtfs_mem region to trigger an XPU violation, causing a crash.
 		 */
@@ -433,7 +434,7 @@ &mdss {
 	status = "okay";
 };
 
-/* Modem/wifi*/
+/* Modem/wifi */
 &mss_pil {
 	status = "okay";
 	firmware-name = "qcom/sdm845/oneplus6/mba.mbn", "qcom/sdm845/oneplus6/modem.mbn";
diff --git a/arch/arm64/boot/dts/qcom/sdm850-samsung-w737.dts b/arch/arm64/boot/dts/qcom/sdm850-samsung-w737.dts
index f93d748e2c94..b712834a5d64 100644
--- a/arch/arm64/boot/dts/qcom/sdm850-samsung-w737.dts
+++ b/arch/arm64/boot/dts/qcom/sdm850-samsung-w737.dts
@@ -43,7 +43,7 @@ chosen {
 		#size-cells = <2>;
 		ranges;
 
-		// Firmware initialized the display at 1280p instead of 1440p
+		/* Firmware initialized the display at 1280p instead of 1440p */
 		framebuffer0: framebuffer@80400000 {
 			compatible = "simple-framebuffer";
 			reg = <0 0x80400000 0 (1920 * 1280 * 4)>;